<?php

/**
 * The plugin to handle full pager with link to all items.
 */
class views_extra_pager_full_all extends views_plugin_pager_full {

  function showing_all() {
    return (!empty($_GET['items_per_page']) && $_GET['items_per_page'] == 'All');
  }

  function use_pager() {
    return ($this->showing_all()) ? FALSE : parent::use_pager();
  }

  function use_count_query() {
    return ($this->showing_all()) ? FALSE : parent::use_count_query();
    return FALSE;
  }

  function get_items_per_page() {
    return ($this->showing_all()) ? 0 : parent::get_items_per_page();
  }

  function query() {
    parent::query();
    if ($this->showing_all()) {
        $this->options['items_per_page'] = 0;
        $this->options['offset'] = 0;
        $this->view->query->set_limit($this->options['items_per_page']);
        $this->view->query->set_offset($this->options['offset']);
    }
  }

  function render($input) {
    if ($this->options['items_per_page'] == 0) {
      return;
    }
    $pager_theme = views_theme_functions('views_extra_pager_full_all', $this->view, $this->display);
    return theme($pager_theme, $input, $this->options['items_per_page'], $this->options['id']);
  }

}
